/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2005 Philippe Delrieu
 * All rights reserved.
 * Contact: openmobileis@e-care.fr
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *  
 *  Modifications :
 *  2005 Creation P.Delrieu
 * 
 */

package org.openmobileis.modules.profils.embedded.data;

import java.util.*;

/**
 * Title:        OpenMobileIS project source <BR>
 * Description: Profil rubvric class
 * @author	Philippe Delrieu
 * @since	JDK 1.1
 * @version 1.0.
 */
public class EmbeddedProfilRubric {

  protected String name;
  protected String description;
  protected boolean isSelected = false;
  protected Hashtable propertiesList;

  public EmbeddedProfilRubric() {
    propertiesList = new Hashtable(5);
  }

  public EmbeddedProfilRubric(String rubName, String rubdescription) {
    this();
    this.name = rubName;
    this.description = rubdescription;
  }

  public void setName (String name) {
    this.name = name;
  }

  public String getName() {
    return name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription (String description) {
    this.description = description;
  }

  public void addProperty(String key, String value) {
    propertiesList.put(key, value);
  }

  public String getProperty(String key) {
    return (String)propertiesList.get(key);
  }

  public boolean removeProperty(String key) {
    return (propertiesList.remove(key) != null);
  }

  public void setSelection (boolean isSelected) {
    this.isSelected = isSelected;
  }

  public boolean isSelected () {
    return isSelected;
  }

  public String getXmlDescription() {
    StringBuffer buffer = new StringBuffer();
    buffer.append("<rubric>\n");
    buffer.append("<name>");
    buffer.append(name);
    buffer.append("</name>\n");
    buffer.append("<description>");
    buffer.append(description);
    buffer.append("</description>\n");
    if (isSelected)
      buffer.append("<selected/>\n");
    Enumeration propEnum = propertiesList.keys();
    while (propEnum.hasMoreElements())  {
      String key = (String) propEnum.nextElement();
      buffer.append("<property key=\"").append(key).append("\" value=\"").append(propertiesList.get(key)).append("\"/>\n");
    }
    buffer.append("</rubric>\n");
    return buffer.toString();
  }
}